#include <iostream>
#include <bits/stdc++.h>
#define MAXN 1000000007
using namespace std;

int main()
{
    vector<int>vek;
    int n,k,p,g;
    long long zbir=0;
    cin>>n>>k;
    for(int i=0;i<n;i++)
    {
        cin>>p;
        vek.push_back(p);
    }
    if(k==0)
        for(int i=0;i<n;i++)
        {
            zbir+=vek[i];
            zbir=zbir%MAXN;
        }
    else
    {
        for(int i=0;i<n;i++)
        {
            for(int j=i;j<n;j++)
            {
                g=i;
                while(g<=j)
                {
                    zbir+=vek[g];
                    zbir=zbir%MAXN;
                    g++;
                }

            }
        }
    }
    cout <<zbir<< endl;
    return 0;
}